%(C)1992 Institute for New Generation Computer Technology
%ۤ¾COPYRIGHTե򻲾ȤƲ
%(Read COPYRIGHT for detailed information.)
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
%       c_subset.esp           1990 09/25
%                                   10/18
%                                   T.Arai
%				1991 07 maruyama
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

    is_partial(Vector):-
        is_partial(Vector,Len).

    unify(X,X,X):-!.
    unify(X,Y,Z):-
        unify_term(X,Y,Z).

    getRole(Pst,Label,Value):-
        is_partial(Pst,Len),
        get_one(One,Pst),
        One= Label/Value.

    %% Pst!label ->value

    get_value(Pst,Ret,Label,Value):-
        nonvar(Pst),
        is_partial(Pst,Len),!,
	length(Pst,Len),
        nonvar(Label),
        get_value(Pst,Ret,Len,Label,Value).

    get_value(Pst,Ret,Label,Value):-
        var(Pst),!,
        Pst = [Label/Value],
        Ret = Pst.

    delete(Label,Pst,Deleted):-
        is_partial(Pst,Len),
        nonvar(Label),
        delete1(Label/Value,Pst,Deleted),!.

    masked_merge(X,Y,Z):-
        var(X),!,
        unify(X,Y,Z).

    masked_merge(X,Y,Z):-
        var(Y),!,
        %% X=Z;
        unify(X,Y,Z).

    masked_merge(X,Y,Z):-
        is_partial(X,L1),
        is_partial(Y,L2),!,
        masked_merge1(X,Y,Merged),
        %%Merged=Z;
        unify(Merged,Z,_).
%% 1991 01/10
%%        Z=Merged;

    %    unify(Merged,Z,Temp).
    
    %  X#Y            
    equiv(X,Y,Z):-
        unify(X,Y,Temp),!,
%% 1991 01/10
        unify(Temp,Z,_).
%%      Z=Temp;

    equiv(X,Y):-
        unify(X,Y).

    update(Pst,Label,Value,New_pst):-
        delete(Label,Pst,Mid),!,
        unify_term(Mid,[Label/Value],New_pst).       

%% maruyama 10.23

    is_partial(Vector,Len):-
        nonvar(Vector),
        length(Vector,Len),
        is_partial1(Vector,0,Len).

    is_partial1([],Len,Len):-!.
    is_partial1(Vector,N,  Len):-
%        vector_element(Vector,N,Element),
%        Element= Label/Value,
	Vector=[Label/Value|R],
        nonvar(Label),!,
        N1 is N+1,
        is_partial1(R,N1,Len).

    unify_term(X,Y,Z):-
        var(X), %!,
        X = Y,!,
        Z = Y.

    unify_term(X,Y,Z):-
        var(Y),%!,
        X = Y,!,    
        Z = X.

    unify_term(X,Y,Z):-
        is_partial(X,L1),
        is_partial(Y,L2),!,
	length(X,L1),
	length(Y,L2),
        unify_next(X,L1,Y,L2,Z). 

   unify_term([X1|L1],[X2|L2],[X3|L3]):-
	unify(X1,X2,X3),
	unify_term(L1,L2,L3).

    unify_next(Vector1,M,Vector2,N,Z) :-
        unify_or_merge(Vector1,Vector2,[],Merged1),
        unify_or_merge(Vector2,Merged1,Merged1,New),
%%                         Rev),
%%        reverse(Rev,[],Merged2),
        Z = New.

    unify_or_merge([],   List2,Result,Result):-!.

    unify_or_merge([H|T],List2,Temp,Result):-
        unify_or_merge1(H,List2,Reply),
        (
         not_included(Reply,Temp),!,
         Next = [Reply|Temp]
            ;
         Next = Temp
        ),
        unify_or_merge(T,List2,Next,Result).

    
    unify_or_merge1(Term,[],Term):-!.

    unify_or_merge1(L/V1,[L/V2|R],Reply):-
        var(V1),
        V1 = V2,!,
        Reply= L/V1.

    unify_or_merge1(L/V1,[L/V2|R],Reply):-
        var(V2),
        V1 = V2,!,
        Reply= L/V1.

    unify_or_merge1(L/V1,[L/V2|R],Reply):-
        is_partial(V1,L1),
        is_partial(V2,L2),!,
	length(V1,L1),
	length(V2,L2),
        unify_term(V1,V2,Merged1),!,
        Reply= L/Merged1.

    unify_or_merge1(L/V1,[L/V2|R],Reply):-!,
%        V1 = V2,!,
	unify(V1,V2,V3),!,
        Reply= L/V3.

    unify_or_merge1(L1/V1,[L2/V2|R],Reply):-!,
        unify_or_merge1(L1/V1,R,Reply).

    unify_or_merge1(L/V1,[L/V2|R],Reply):-!,fail.


    get_one(X,[X|Rest]).

    get_one(X,[Y|Rest]):-
        get_one(X,Rest).

    list_to_vector(List,Vector):-
        list_length(List,0,Length),
        new_stack_vector(Vector,Length),
        list_to_vector1(List,Vector,0,Length).

    list_to_vector1([],New,Len,Len):-!.

    list_to_vector1([X|Y],New,P,Len):-!,
        vector_element(New,P,X),
        P1 = P+1,
        list_to_vector1(Y,New,P1,Len).

    vector_to_list(Vector,List):-
        stack_vector(Vector,Len),
        vector_to_list1(Vector,0,Len,[],List).

    vector_to_list1(Vector,Len,Len,List,List):-!.

    vector_to_list1(Vector,N,  Len,Temp,   List):-!,
        vector_element(Vector,N,Element),
        N1 = N+1,
        vector_to_list1(Vector,N1,Len,[Element|Temp],List).

    list_length([],Len,Len):-!.

    list_length([X|Y],N,Len):-!,
        N1 = N+1,
        list_length(Y,N1,Len).
    
    not_included(Element,[]):-!.

    not_included(Label/V,[Label/Val|T]):-!,fail.

    not_included(Element,[H|T]):-!,
        not_included(Element,T).

    copy_vector(New,P,Y,Len,Len):-!. 
 
    copy_vector(New,P,Y,L,  Len):-!, 
        vector_element(Y,L,Element), 
        vector_element(New,P,Element), 
        P1 = P+1, 
        L1 = L +1,
    copy_vector(New,P1,Y,L1,Len). 
 
    get_value(Vector,Ret,Len,Label,Value):-
        get_value1(Vector,Ret,Vector,Label,Value).

    get_value1(Vector,Ret,[],Label,Value):-!,
        unify_term(Vector,[Label/Value],Ret).
    get_value1(Vector,Vector,[Label/Value|R],Label,Value):-!.
    get_value1(Vector,Ret,[_|R],Label,Value):-!,
         get_value1(Vector,Ret,R,Label,Value).
    delete1(Term,List,Deleted):-
        delete1(Term,List,[],Deleted).

    delete1(Term,[],Deleted,Deleted):-!.

    delete1(Term,[Term1|Rest],Temp,Deleted):-
        (Term=Term1,!,
         Ntemp=Temp
            ;
         Ntemp=[Term1|Temp]
        ),
        delete1(Term,Rest,Ntemp,Deleted).
        
    masked_merge1(List,[],List):-!.

    masked_merge1(List1,[Term|Rest],List):-!,
        delete_element(List1,Term,[],Deleted),
        masked_merge1(Deleted,Rest,List).

    delete_element([],Term,Deleted,Deleted):-!.

    delete_element([L/V1|R],L/V,Temp,Deleted):-!,
        delete_element(R,L/V,Temp,Deleted).

    delete_element([H|R],L/V,Temp,Deleted):-!,
        delete_element(R,L/V,[H|Temp],Deleted).

    record(Vect,List):-
        record1(Vect,[],List).

    record1([],List,List):-!.

    record1([H|Rest],Mid,List):-
        H= Label/Value,!,
        record1(Rest,[(Label,Value)|Mid],List).

    % Caution!
    % H= space dd/dd.

    reverse([],List,List):-!.

    reverse([X|Y],Z,List):-!,
        reverse(Y,[X|Z],List).









